unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Spin, StdCtrls, ExtCtrls, PolyText, Buttons;

Type  TOwnPolyTyp = Class(TPolyTextTyp)
      Private
       FUF : Boolean;
      Public
       Procedure   UserDefined(PolyPointsCnt : Integer;
                               Var PolyPoints : Array Of TPoint); Override;
      End;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    FontDialog1: TFontDialog;
    BitBtn1: TBitBtn;
    GroupBox1: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    PenWidth: TSpinEdit;
    Label2: TLabel;
    SameCol: TCheckBox;
    ColorDialog1: TColorDialog;
    GroupBox2: TGroupBox;
    Edit1: TEdit;
    AutoCheck: TCheckBox;
    GroupBox3: TGroupBox;
    HorMirr: TCheckBox;
    VerMirr: TCheckBox;
    RotCheck: TCheckBox;
    UserCheck: TCheckBox;
    DegEdit: TSpinEdit;
    Label1: TLabel;
    vg: TRadioGroup;
    hg: TRadioGroup;
    CalcCheck: TCheckBox;
    SX: TSpinEdit;
    SY: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure AutoCheckClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure UserCheckClick(Sender: TObject);
    procedure DegEditChange(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure PenWidthChange(Sender: TObject);
    procedure SameColClick(Sender: TObject);
    procedure HorMirrClick(Sender: TObject);
    procedure VerMirrClick(Sender: TObject);
    procedure RotCheckClick(Sender: TObject);
    procedure vgClick(Sender: TObject);
    procedure hgClick(Sender: TObject);
    procedure CalcCheckClick(Sender: TObject);
    procedure SXChange(Sender: TObject);
    procedure SYChange(Sender: TObject);
  private
    { Private-Deklarationen}
    FOwnPoly : TOwnPolyTyp;
    FFillCol : TColor;        (* font color *)
    FPenCol  : TColor;        (* font outline color *)
    FPenSize : Integer;       (* font outline line size *)
    Function   GetColor (P_Val : TColor) : TColor;
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Procedure TOwnPolyTyp.UserDefined(PolyPointsCnt : Integer;
                                  Var PolyPoints : Array Of TPoint);
Var       l_i, l_x, l_y : Integer;
          l_p : Real;
Begin
 For l_i := 0 To Pred(PolyPointsCnt) do
  Begin
   l_x := (PolyPoints[l_i].x - TextStartX);
   l_y := (PolyPoints[l_i].y - TextMidY);
   l_p := Sin((l_x Mod 180) * Pi / 180);
   PolyPoints[l_i].y := TextMidY + Round(l_y * l_p);
  End;
End;

Function  TForm1.GetColor (P_Val : TColor) : TColor;
Begin
 With ColorDialog1 Do
  Begin
   Color := P_Val;
   If Execute Then Result := Color
              Else Result := P_Val;
  End;
End;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 With PaintBox1 Do
  Begin
   Canvas.Brush.Color := clWhite;
   Canvas.Brush.Style := bsSolid;
   Canvas.Pen.Color := clBlack;
   Canvas.Rectangle(0, 0, Width, Height);
  End;
 With PaintBox1 Do
  Begin
   Canvas.Brush.Color := FFillCol;
   If SameCol.Checked = False Then Canvas.Pen.Color := FPenCol
                              Else Canvas.Pen.Color := FFillCol;
   Canvas.Pen.Width := PenWidth.Value;
   Canvas.Font.Assign(FontDialog1.Font);
   FOwnPoly.Text := Edit1.Text;
   FOwnPoly.DrawText;
  End;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 FOwnPoly := TOwnPolyTyp.Create;
 With FontDialog1 Do
  Begin
   Font.Name := 'Arial';
   Font.Height := 200;
  End;
 FPenSize := 1;
 FPenCol := clBlack;
 FFillCol := clBlack;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 FOwnPoly.Free;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 With FOwnPoly Do
  Begin
   TextCanvas := PaintBox1.Canvas;
   AutoStretch := AutoCheck.Checked;
   Align_Hor := taCenter;
   Align_Ver := taVCenter;
   Frame := Rect(PaintBox1.Left, PaintBox1.Top,
                 PaintBox1.Width, PaintBox1.Height);
   vg.ItemIndex := Ord(Align_Ver);
   hg.ItemIndex := Ord(Align_Hor);
  End;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 With FontDialog1 Do
  Begin
   Font.Assign(PaintBox1.Canvas.Font);
   If Execute Then
    Invalidate;
  End;
end;

procedure TForm1.AutoCheckClick(Sender: TObject);
begin
 FOwnPoly.AutoStretch := AutoCheck.Checked;
 SX.Enabled := Not AutoCheck.Checked;
 SY.Enabled := Not AutoCheck.Checked;
 Invalidate;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
 Invalidate;
end;

procedure TForm1.UserCheckClick(Sender: TObject);
begin
 FOwnPoly.PE_UserDefined := UserCheck.Checked;
 Invalidate;
end;

procedure TForm1.DegEditChange(Sender: TObject);
begin
 FOwnPoly.Degree := DegEdit.Value;
 Invalidate;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 Caption := FontDialog1.Font.Name;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 FFillCol := GetColor(FFillCol);
 Invalidate;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 FPenCol := GetColor(FPenCol);
 Invalidate;
end;

procedure TForm1.PenWidthChange(Sender: TObject);
begin
 Invalidate;
end;

procedure TForm1.SameColClick(Sender: TObject);
begin
 Invalidate;
end;

procedure TForm1.HorMirrClick(Sender: TObject);
begin
 FOwnPoly.PE_Hor_Mirr := HorMirr.Checked;
 Invalidate;
end;

procedure TForm1.VerMirrClick(Sender: TObject);
begin
 FOwnPoly.PE_Ver_Mirr := VerMirr.Checked;
 Invalidate;
end;

procedure TForm1.RotCheckClick(Sender: TObject);
begin
 FOwnPoly.PE_Rotate := RotCheck.Checked;
 Invalidate;
end;

procedure TForm1.vgClick(Sender: TObject);
begin
 FOwnPoly.Align_Ver := TAlignVer(vg.ItemIndex);
 Invalidate;
end;

procedure TForm1.hgClick(Sender: TObject);
begin
 FOwnPoly.Align_Hor := TAlignment(hg.ItemIndex);
 Invalidate;
end;

procedure TForm1.CalcCheckClick(Sender: TObject);
begin
 FOwnPoly.CalcLinePoints := CalcCheck.Checked;
 Invalidate;
end;

procedure TForm1.SXChange(Sender: TObject);
begin
 FOwnPoly.Stretch_Hor := SX.Value / 100;
 Invalidate;
end;

procedure TForm1.SYChange(Sender: TObject);
begin
 FOwnPoly.Stretch_Ver := SY.Value / 100;
 Invalidate;
end;

end.
